## sources-251126-revpi-bookworm-arm64-lite.tar.zst

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2024 KUNBUS GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
cmake_minimum_required(VERSION 3.13)

project(revpi-sos)

include(GNUInstallDirs)
find_package(Python3 COMPONENTS Interpreter Development REQUIRED)

install(PROGRAMS revpi-sos
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(FILES plugins/revpi.py plugins/revpi-eep.py plugins/revpi-codesys.py
  DESTINATION ${Python3_SITELIB}/sos/report/plugins/
)

add_custom_target(
  revpi-sos.1 ALL
  COMMAND scdoc < ${CMAKE_SOURCE_DIR}/revpi-sos.1.scd > ${PROJECT_BINARY_DIR}/revpi-sos.1
  DEPENDS ${CMAKE_SOURCE_DIR}/revpi-sos.1.scd
)

install(FILES ${PROJECT_BINARY_DIR}/revpi-sos.1
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/
)

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
VERSION = 6
PATCHLEVEL = 12
SUBLEVEL = 56
EXTRAVERSION =
NAME = Baby Opossum Posse

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

ifeq ($(filter output-sync,$(.FEATURES)),)
$(error GNU Make >= 4.0 is required. Your Make version is $(MAKE_VERSION))
endif

$(if $(filter __%, $(MAKECMDGOALS)), \
	$(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.a targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

this-makefile := $(lastword $(MAKEFILE_LIST))
abs_srctree := $(realpath $(dir $(this-makefile)))
abs_objtree := $(CURDIR)

ifneq ($(sub_make_done),1)

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# Beautify output
# ---------------------------------------------------------------------------
#
# Most of build commands in Kbuild start with "cmd_". You can optionally define
# "quiet_cmd_*". If defined, the short log is printed. Otherwise, no log from
# that command is printed by default.
#
# e.g.)
#    quiet_cmd_depmod = DEPMOD  $(MODLIB)
#          cmd_depmod = $(srctree)/scripts/depmod.sh $(DEPMOD) $(KERNELRELEASE)
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#    $(Q)$(MAKE) $(build)=scripts/basic
#
# If KBUILD_VERBOSE contains 1, the whole command is echoed.
# If KBUILD_VERBOSE contains 2, the reason for rebuilding is printed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif

quiet = quiet_
Q = @

ifneq ($(findstring 1, $(KBUILD_VERBOSE)),)
  quiet =
  Q =
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands
ifneq ($(findstring s,$(firstword -$(MAKEFLAGS))),)
quiet=silent_
override KBUILD_VERBOSE :=
endif

export quiet Q KBUILD_VERBOSE

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/dev-tools/sparse.rst" for more details,
# including where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

export KBUILD_CHECKSRC

# Enable "clippy" (a linter) as part of the Rust compilation.
#
# Use 'make CLIPPY=1' to enable it.
ifeq ("$(origin CLIPPY)", "command line")
  KBUILD_CLIPPY := $(CLIPPY)
endif

export KBUILD_CLIPPY

# Use make M=dir or set the environment variable KBUILD_EXTMOD to specify the
# directory of external module to build. Setting M= takes precedence.
ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

$(if $(word 2, $(KBUILD_EXTMOD)), \
	$(error building multiple external modules is not supported))

$(foreach x, % :, $(if $(findstring $x, $(KBUILD_EXTMOD)), \
	$(error module directory path cannot contain '$x')))

# Remove trailing slashes
ifneq ($(filter %/, $(KBUILD_EXTMOD)),)
KBUILD_EXTMOD := $(shell dirname $(KBUILD_EXTMOD).)
endif

export KBUILD_EXTMOD

# backward compatibility
KBUILD_EXTRA_WARN ?= $(KBUILD_ENABLE_EXTRA_GCC_CHECKS)

ifeq ("$(origin W)", "command line")
  KBUILD_EXTRA_WARN := $(W)
endif

export KBUILD_EXTRA_WARN

# Kbuild will save output files in the current working directory.
# This does not need to match to the root of the kernel source tree.
#
# For example, you can do this:
#
#  cd /dir/to/store/output/files; make -f /dir/to/kernel/source/Makefile
#
# If you want to save output files in a different location, there are
# two syntaxes to specify it.
#
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the output directory.
# export KBUILD_OUTPUT=dir/to/store/output/files/; make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Do we want to change the working directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# $(realpath ...) gets empty if the path does not exist. Run 'mkdir -p' first.
$(shell mkdir -p "$(KBUILD_OUTPUT)")
# $(realpath ...) resolves symlinks
abs_objtree := $(realpath $(KBUILD_OUTPUT))
$(if $(abs_objtree),,$(error failed to create output directory "$(KBUILD_OUTPUT)"))
endif # ifneq ($(KBUILD_OUTPUT),)

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

export sub_make_done := 1

endif # sub_make_done

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." if we are at the final work directory.
no-print-directory := --no-print-directory
else
# Recursion to show "Entering directory ..."
need-sub-make := 1
endif

ifeq ($(filter --no-print-directory, $(MAKEFLAGS)),)
# If --no-print-directory is unset, recurse once again to set it.
# You may end up recursing into __sub-make twice. This is needed due to the
# behavior change in GNU Make 4.4.1.
need-sub-make := 1
endif

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) $(no-print-directory) -C $(abs_objtree) \
	-f $(abs_srctree)/Makefile $(MAKECMDGOALS)

else # need-sub-make

# We process the rest of the Makefile if this is the final invocation of make

ifeq ($(abs_srctree),$(abs_objtree))
        # building in the source tree
        srctree := .
	building_out_of_srctree :=
else
        ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(abs_srctree)
        endif
	building_out_of_srctree := 1
endif

ifneq ($(KBUILD_ABS_SRCTREE),)
srctree := $(abs_srctree)
endif

objtree		:= .

VPATH		:=

ifeq ($(KBUILD_EXTMOD),)
ifdef building_out_of_srctree
VPATH		:= $(srctree)
endif
endif

export building_out_of_srctree srctree objtree VPATH

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/uapi/linux/version.h

clean-targets := %clean mrproper cleandocs
no-dot-config-targets := $(clean-targets) \
			 cscope gtags TAGS tags help% %docs check% coccicheck \
			 $(version_h) headers headers_% archheaders archscripts \
			 %asm-generic kernelversion %src-pkg dt_binding_check \
			 outputmakefile rustavailable rustfmt rustfmtcheck
no-sync-config-targets := $(no-dot-config-targets) %install modules_sign kernelrelease \
			  image_name
single-targets := %.a %.i %.ko %.lds %.ll %.lst %.mod %.o %.rsi %.s %.symtypes %/

config-build	:=
mixed-build	:=
need-config	:= 1
may-sync-config	:= 1
single-build	:=

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config :=
    endif
endif

ifneq ($(filter $(no-sync-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-sync-config-targets), $(MAKECMDGOALS)),)
        may-sync-config :=
    endif
endif

need-compiler := $(may-sync-config)

ifneq ($(KBUILD_EXTMOD),)
    may-sync-config :=
endif

ifeq ($(KBUILD_EXTMOD),)
    ifneq ($(filter %config,$(MAKECMDGOALS)),)
        config-build := 1
        ifneq ($(words $(MAKECMDGOALS)),1)
            mixed-build := 1
        endif
    endif
endif

# We cannot build single targets and the others at the same time
ifneq ($(filter $(single-targets), $(MAKECMDGOALS)),)
    single-build := 1
    ifneq ($(filter-out $(single-targets), $(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# For "make -j clean all", "make -j mrproper defconfig all", etc.
ifneq ($(filter $(clean-targets),$(MAKECMDGOALS)),)
    ifneq ($(filter-out $(clean-targets),$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# install and modules_install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
    ifneq ($(filter modules_install,$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

ifdef mixed-build
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(MAKECMDGOALS): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else # !mixed-build

include $(srctree)/scripts/Kbuild.include

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(call read-file, include/config/kernel.release)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION

include $(srctree)/scripts/subarch.include

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=arm64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=aarch64-linux-gnu-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for parisc
ifeq ($(ARCH),parisc64)
       SRCARCH := parisc
endif

export cross_compiling :=
ifneq ($(SRCARCH),$(SUBARCH))
cross_compiling := 1

=== requirements.txt ===
# SPDX-FileCopyrightText: 2024 KUNBUS GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later

# Build dependencies
pip-licenses
Pyinstaller
pytest-cov
setuptools
wheel

# Runtime dependencies, must match install_requires in setup.py
custom_rap_installer
paho-mqtt >= 1.0, < 2.0.0
revpimodio2 >= 2.6.0

=== avahi-services/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# SPDX-FileCopyrightText: 2024-2025 KUNBUS GmbH

install(FILES revpi-ssh.service
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/avahi/services
)

=== conf.d/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 KUNBUS GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later

install(FILES 99-revpi.conf
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/NetworkManager/conf.d/
)

=== doc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 KUNBUS GmbH
#
# SPDX-License-Identifier: MIT

add_custom_target(
	piTest.1 ALL
	COMMAND scdoc < ${CMAKE_SOURCE_DIR}/doc/piTest.1.scd > ${PROJECT_BINARY_DIR}/piTest.1
	DEPENDS ${CMAKE_SOURCE_DIR}/doc/piTest.1.scd
)

install(FILES ${PROJECT_BINARY_DIR}/piTest.1
	DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/
)

install(FILES ../lib/piControl/src/picontrol_ioctl.4 DESTINATION ${CMAKE_INSTALL_MANDIR}/man4)

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: KUNBUS GmbH <support@kunbus.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later

install(FILES piSerial.8
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man8/
)

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

clean:
	rm -R $(BUILDDIR)

.PHONY: help clean Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
Sphinx>=5.1.0
pydata-sphinx-theme>=0.9.0
# sphinx-copybutton>=0.5.0

# Optional Dependencies
sphinx-autobuild>=2021.3.14

=== etc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 KUNBUS GmbH <support@kunbus.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later

install(FILES modules-load.d/piserial.conf
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/modules-load.d/
)

=== firmware/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 KUNBUS GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later

install(FILES brcmfmac43455-sdio.kunbus,revpi-flat.bin brcmfmac43455-sdio.kunbus,revpi-flat.clm_blob brcmfmac43455-sdio.kunbus,revpi-flat.txt
  DESTINATION /usr/lib/firmware/brcm/
)

=== piControl/Makefile ===

#CC=/usr/bin/arm-linux-gnueabihf-gcc

obj-m   := piControl.o

#add other objects e.g. test.o
piControl-objs  = piControlMain.o
piControl-objs += piIOComm.o
piControl-objs += piDIOComm.o
piControl-objs += piAIOComm.o
piControl-objs += RevPiDevice.o
piControl-objs += json.o
piControl-objs += piConfig.o
piControl-objs += RS485FwuCommand.o
piControl-objs += piFirmwareUpdate.o
piControl-objs += PiBridgeMaster.o
piControl-objs += kbUtilities.o
piControl-objs += systick.o
piControl-objs += revpi_common.o
piControl-objs += revpi_compact.o
piControl-objs += revpi_core.o
piControl-objs += revpi_gate.o
piControl-objs += revpi_flat.o
piControl-objs += pt100.o
piControl-objs += revpi_mio.o

ccflags-y := -O2
ccflags-$(_ACPI_DEBUG) += -DACPI_DEBUG_OUTPUT

#KDIR    := /home/md/pi/kernelbakery/kbuild7
KBUILD_CFLAGS += -g

PWD   	:= $(shell pwd)

EXTRA_CFLAGS = -I$(src)/

EXTRA_CFLAGS += -D__KUNBUSPI_KERNEL__

CROSS_COMPILE += arm-linux-gnueabihf-

.PHONY: compiletime.h

all: compiletime.h
	$(MAKE) ARCH=arm CROSS_COMPILE="$(CROSS_COMPILE)" -C $(KDIR) M=$(PWD)  modules

compiletime.h:
	echo "#define COMPILETIME \""`date`"\"" > compiletime.h

clean:
	$(MAKE) ARCH=arm -C $(KDIR) M=$(PWD) clean
	rm -f $(piControl-objs)

=== changelog ===
glibc (2.36-9+rpt2+deb12u13) bookworm; urgency=medium

  * widevine patches from libreelec
    - https://github.com/LibreELEC/LibreELEC.tv/tree/41ca868/packages/devel/glibc/patches/arm
    - glibc-HACK-Don-t-check-GLIBC_ABI_DT_RELR-support-for-Chrom.patch
    - glibc-tls-libwidevinecdm.so-since-4.10.2252.0-has-TLS-with.patch
  * Update glibc-HACK-Don-t-check-GLIBC_ABI_DT_RELR-support-for-Chrom.patch
    - search for libwidevine instead of libwidevine.so substring to handle
      our use of libwidevine_real.so on arm64

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 08 Oct 2025 13:49:58 +0100

glibc (2.36-9+deb12u13) bookworm; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix error reporting (false negatives) in SGID tests
    - Fix double-free after allocation failure in regcomp (GLIBC-SA-2025-0005
      / CVE-2025-8058).  Closes: #1109803.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 25 Aug 2025 21:11:05 +0200

glibc (2.36-9+deb12u12) bookworm; urgency=medium

  * d/p/local-revert-aarch64-use-prefer_sve_ifuncs-for-sve-memset.diff: revert
    upstream commit "AArch64: Use prefer_sve_ifuncs for SVE memset" as
    upstream commit "AArch64: Check kernel version for SVE ifuncs" has been
    reverted in 2.36-9+deb12u9.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 02 Jun 2025 22:53:56 +0200

glibc (2.36-9+deb12u11) bookworm; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixed incorrect LD_LIBRARY_PATH search in dlopen for static setuid
      binaries (GLIBC-SA-2025-0002 / CVE-2025-4802).
    - Improve memory layout of structures in exp/exp10/expf functions.
    - Add an SVE implementation of memset on aarch64.
    - Improve generic implementation of memset on aarch64.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 29 May 2025 11:41:11 +0200

glibc (2.36-9+deb12u10) bookworm; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Change ldconfig auxcache magic number.
    - Ensure data passed to the rseq syscall are properly initialized.
    - Avoid integer truncation when parsing CPUID data with large cache sizes,
      fixing a memcpy/memmove when running under the FreeBSD's bhyve
      hypervisor.
    - Optimize log2/expm1/log1p math functions with FMA.
    - Fix missing cache information when running under Azure TDX hypervisor.
    - Fix TLS performance degradation after dlopen() usage.
    - Fix memset performance for unaligned destinations causing additional
      loop iterations.
    - Fixes a buffer overflow when printing assertion failure message
      (GLIBC-SA-2025-0001 / CVE-2025-0395).

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 06 Mar 2025 23:46:53 +0100

glibc (2.36-9+deb12u9) bookworm; urgency=medium

  * debian/testsuite-xfail-debian.mk: mark tst-support_descriptors as XFAIL,
    due to sbuild bug #1070003.
  * debian/patches/localedata/git-locale-hr_HR-euro.diff: change Croatian
    locale to use Euro as currency.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - resolv: do not ignore short error responses (as generated by e.g.
      Unbound) to avoid timeouts.
    - resolv: fix timeouts when single-request mode is enabled in resolv.conf.
    - resolv: fix reloading resolv.conf when a nameserver has been
      automatically switched to single-request mode.
    - mremap(): fix support for the MREMAP_DONTUNMAP option.
    - fortification: fix name space violation in fortify wrappers.
    - vfscanf(): fix matches longer than INT_MAX.
    - ungetc(): fix uninitialized read when putting into unused streams.
    - ungetc(): fix backup buffer leak on program exit.
  * patches/arm64/local-revert-aarch64-check-kernel-version-for-sve-ifuncs.diff:
    revert upstream commit as it changes the GLIBC_PRIVATE ABI, causing
    crashes with static binaries using dlopened NSS functions.  Closes:
    #1083095.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 01 Nov 2024 13:42:20 +0100

glibc (2.36-9+deb12u8) bookworm; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/kfreebsd/submitted-auxv.diff: refreshed.
    - debian/patches/any/local-CVE-2024-2961-iso-2022-cn-ext.diff: upstreamed.
    - debian/patches/any/local-CVE-2024-33599-nscd.diff: upstreamed.
    - debian/patches/any/local-CVE-2024-33600-nscd.diff: upstreamed.
    - debian/patches/any/local-CVE-2024-33601-33602-nscd.diff: upstreamed.
    - Fixes ffsll() performance issue depending on code alignment.
    - Fixes memmove/memset on sparc32.
    - Fixes pthread_cancel on sparc32.
    - Fixes a possible crash in _dl_start_user on arm32.
    - Fixes poor malloc/free performance due to lock contentions between
      threads when using core pinning.
    - Uses 64-bit time_t in testsuite on 32-bit systems.
    - Fixes rseq support when built against newer kernel headers.
    - Performance improvements for string functions on arm64.
    - Disables arm64 SVE functions on kernel <= 6.2.0 due to performance
      issues.
    - Fixes ld.so crash on powerpc64* when built with GCC 14.
    - Fixes ld.so crash on amd64 when built with APX enabled.
    - Fixes __WORDSIZE definition on sparc32 with sparcv9.
    - Fixes getutxent() on 32-bit architecture with _TIME_BITS=64.
    - Fixes y2038 regression in nscd following CVE-2024-33601 and
      CVE-2024-33602 fix.
    - Fixes build with --enable-hardcoded-path-in-tests with newer linkers.
    - Fixes crash in wcsncmp() in z13/vector-optimized s390 implementation.
    - Fixes rseq extension mechanism.
    - Fixes misc/tst-preadvwritev2 and misc/tst-preadvwritev64v2 with kernel
      6.9+.
    - Fixes freeing uninitialized memory in libc_freeres_fn().  Closes:
      #1073916.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 15 Aug 2024 11:10:46 +0200

glibc (2.36-9+deb12u7) bookworm-security; urgency=medium



=== debian/changelog ===
initramfs-tools (0.142+rpt4+deb12u3) bookworm; urgency=medium

  * Change default RUNSIZE to 20%

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 21 Jul 2025 08:35:00 +0100

initramfs-tools (0.142+rpt3+deb12u3) bookworm; urgency=medium

  * Run zstd with --single-thread on devices with < 1GB RAM
  * If update_initramfs=yes, upate initramfs for all flavours of the
    latest rpi kernel version
  * Handle older ABI version format

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 12 May 2025 11:51:30 +0100

initramfs-tools (0.142+deb12u3) bookworm; urgency=medium

  * Re-upload with clean debian directory

 -- Ben Hutchings <benh@debian.org>  Sat, 26 Apr 2025 21:17:01 +0200

initramfs-tools (0.142+deb12u2) bookworm; urgency=medium

  * [37a6e9e] hook-functions: Expand documentation of copy_exec and copy_file
  * [31c50bc] hook-functions: Restore copy_file's handling of target ending in
    slash (Closes: #1082647)
  * [d6d1883] hook-functions: Exclude usr-merge symlinks in copy_file
    (Closes: #1088959)
  * [38cf275] autopkgtest: Add tests for copy_file function
  * [065a03f] hook-functions: Add reset drivers when MODULES=dep
    (Closes: #1027458)

 -- Ben Hutchings <benh@debian.org>  Thu, 24 Apr 2025 17:45:07 +0200

initramfs-tools (0.142+deb12u1) bookworm; urgency=medium

  [ Ben Hutchings ]
  * [522d475] d/salsa-ci.yml: Set RELEASE to bookworm
  * [05e5fb9] hook_functions: Fix copy_file with source including a directory
    symlink (Closes: #1076539)
  * [f52ae2d] hook-functions: copy_file: Canonicalise target filename
    (Closes: #1079276)

  [ szubersk ]
  * [d502a7f] Fix/ignore ShellCheck findings

  [ Benjamin Drung ]
  * [ce185c3] test: Fix too small ext2 block count
  * [cd5e8e8] install hid-multitouch module for Surface Pro 4 Keyboard
    (LP: #1772094)

  [ Arnaud Rebillout ]
  * [4cc2bc7] Add hyper-keyboard module, needed to enter LUKS password in
    Hyper-V (Closes: #1028511)

  [ Alper Nebi Yasak ]
  * [5d28dad] hook-functions: auto_add_modules: Add onboard_usb_hub,
    onboard_usb_dev

 -- Ben Hutchings <benh@debian.org>  Sun, 25 Aug 2024 01:14:50 +0200

initramfs-tools (0.142) unstable; urgency=medium

  [ Dan Streetman ]
  * [8c9840e] hooks/fsck: always include fsck binary (LP: #1917780)

  [ Dimitri John Ledkov ]
  * [d8c5864] mkinitramfs: decompress compressed kernel modules

  [ szubersk ]
  * [e447e91] resume: Don't resume from a swap device on a ZVOL

  [ Johannes Schauer Marin Rodrigues ]
  * [834d01d] hook-functions: Add pwm-imx27, nwl-dsi, ti-sn65dsi86,
    imx-dcss, mxsfb, mux-mmio and imx8mq-interconnect for MNT Reform 2
    panel/backlight.

  [ Rich Ercolani ]
  * [50d945a] Add support for specifying compression level

  [ Ben Hutchings ]
  * [5bf479d] hook-functions: Remove support for ieee1394 and i2o
  * [9a4d579] hook-functions: auto_add_modules: Include UFS drivers from
    drivers/ufs/

  [ Sven Joachim ]
  * [c064b9e] Copy modules.builtin.modinfo into initramfs (Closes: #1014319)

 -- Ben Hutchings <benh@debian.org>  Tue, 12 Jul 2022 23:51:34 +0200

initramfs-tools (0.141) unstable; urgency=medium

  [ Hideki Yamane ]
  * [742c8ee] Use zstd as default compression for initramfs (Closes: #976054)
  * [b6ccfb6] Recommends: s/pigz/zstd/
  * [1063c43] Add check whether zstd support kernel (>= 5.9) and
    CONFIG_RD_ZSTD=y or not
  * [71c29fd] As comparison, compression level 9 is better.
  * [9cee2f0] Consider SOURCE_DATE_EPOCH option for zstd

  [ Alper Nebi Yasak ]
  * [db7aec4] hook-functions: Include io-domain in dw_mmc-rockchip hidden
    dependencies

  [ Michael Biebl ]
  * [7ec5e26] Setup /dev/fd and /dev/std{in,out,err} after mounting devtmpfs
    (Closes: #981302)

  [ Dan Streetman ]
  * [116b532] hook-functions: check for dir before running find on it
    (LP: #1927779)

  [ Vagrant Cascadian ]
  * [a5d9b32] hook-functions: Add pwm-rockchip to "fb" modules for Pinebook PRO
    LCD display.
  * [7e15676] hook-functions: Add usb/typec/tcpm modules to support keyboard on
    Pinebook PRO.
  * [5f17c03] hook-functions: Add panel-edp to "fb" modules for Pinebook PRO
    LCD display.

  [ Ben Hutchings ]
  * [26f2f00] Only run shellcheck in Salsa CI (Closes: #992798)
  * [bd1519b] Fix shellcheck warning "Avoid x-prefix in comparisons ..."
  * [4937118] hook-functions: Fix shellcheck warning "Expansions inside ${..}
    need to be ..."
  * [883f4ad] mkiniramfs: Log warning about missing compressor to stderr
  * [035190c] mkinitramfs: Generalise kernel compression support check
  * [58e05e4] d/salsa-ci.yml: Disable non-arch:all builds
  * [5679e26] debian/tests/control: Add zstd as dependency to avoid (fatal)
    warnings
  * [e856af4] hook-functions: Support network boot via USB Ethernet adapters
    (Closes: #980788)
  * [ec5c6c7] scripts/functions: Refactor device name logic in
    configure_networking
  * [80eddcf] scripts/functions: Make configure_networking wait for device
    specified any way (Closes: #911727)

  [ Ben Love ]
  * [02dc65f] Fully-qualify modprobe calls to avoid busybox

  [ Ariel D'Alessandro ]
  * [8a6f73c] hook-functions: Add nvmem-imx-ocotp driver module to network boot

 -- Ben Hutchings <benh@debian.org>  Sun, 10 Apr 2022 23:39:45 +0200

initramfs-tools (0.140) unstable; urgency=medium

  [ Norbert Lange ]
  * mkinitramfs: use temporary file for uncompressed cpio

  [ Michael Prokop ]
  * mkinitramfs: report actually requested compress util if it's not present

  [ Ben Hutchings ]
  * init: Mount /dev without the noexec option

  [ dann frazier ]
  * configure_networking(): Wait for specified network device (Closes: #965935)

  [ Bastian Blank ]
  * Include all PCI controller modules
  * Include all reset controller modules

 -- Bastian Blank <waldi@debian.org>  Sat, 13 Mar 2021 19:13:18 +0100

initramfs-tools (0.139) unstable; urgency=medium

  * [9679f0c] debian/tests: Run amd64 tests on either amd64 or generic flavour
  * [0099040] debian/tests/control: Mark all amd64 tests as


=== piControl/debian/changelog ===
picontrol (1.3.1-1) stable; urgency=medium

  * Make CROSS_COMPILE optionally configureable from environment
  * Allow spaces (two commands) in CROSS_COMPILE environment variable
  * piControl: Dont use wrong offset for default values
  * debia/control: Correct Maintainer entry.

 -- Lino Sanfilippo <l.sanfilippo@kunbus.com>  Tue, 16 Mar 2021 13:17:05 +0100

picontrol (1.3.0-1) stable; urgency=medium

  * Add RevPi MIO support

 -- Philipp Rosenberger <p.rosenberger@kunbus.com>  Wed, 10 Mar 2021 14:06:05 +0100

picontrol (1.3.0-1~0flat1) stable; urgency=medium

  * Beta release for KUNBUS RevPi Flat.
  * Add the revpi flat name to the list of known module names.

 -- Philipp Rosenberger <p.rosenberger@kunbus.com>  Mon, 26 Oct 2020 12:43:41 +0100

picontrol (1.2.1-1) stable; urgency=medium

  * Show names of the new Connect modules

 -- Kunbus <admin@kunbus.de>  Tue, 29 May 2018 09:15:00 +0200

picontrol (1.2.0-2) stable; urgency=medium

  * Install ioctl manual page

 -- Kunbus <admin@kunbus.de>  Wed, 04 Apr 2018 13:15:00 +0200

picontrol (1.2.0-1) stable; urgency=medium

  * Some new ioctl calls
  * new manual page

 -- Kunbus <admin@kunbus.de>  Fri, 23 Mar 2018 13:50:00 +0200

picontrol (1.1.1-1) stable; urgency=medium

  * Bugfix in piControlIf

 -- Kunbus <admin@kunbus.de>  Wed, 20 Sep 2017 09:50:28 +0200

picontrol (1.1.0-1) stable; urgency=medium

  * Initial release

 -- Kunbus <admin@kunbus.de>  Fri, 27 Jan 2017 13:50:00 +0100

=== control ===
Source: firmware-nonfree
Section: non-free-firmware/kernel
Priority: optional
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Steve Langasek <vorlon@debian.org>, maximilian attems <maks@debian.org>, Ben Hutchings <benh@debian.org>, Salvatore Bonaccorso <carnil@debian.org>
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 13), rdfind
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/kernel-team/firmware-nonfree
Vcs-Git: https://salsa.debian.org/kernel-team/firmware-nonfree.git
XS-Autobuild: yes

Package: firmware-amd-graphics
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for AMD/ATI graphics chips
 This package contains the binary firmware for AMD/ATI graphics chips
 supported by the radeon, amdgpu and r128 drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-atheros
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Qualcomm Atheros wireless cards
 This package contains the binary firmware for USB wireless network and
 Bluetooth cards supported by the ar5523, ath3k, ath6kl_sdio, ath6kl_usb,
 ath10k, ath11k, or wilc6210 drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-bnx2
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Broadcom NetXtremeII
 This package contains the binary firmware for Broadcom NetXtremeII network
 adapters supported by the bnx2 driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-bnx2x
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Broadcom NetXtreme II 10Gb
 This package contains the binary firmware for Broadcom NetXtreme II 10Gb
 network adapters supported by the bnx2x driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-brcm80211
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Broadcom/Cypress 802.11 wireless cards
 This package contains the binary firmware for wireless network cards
 supported by the brcmsmac or brcmfmac driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-cavium
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Cavium Ethernet adapters
 This package contains the binary firmware for Cavium crypto and Ethernet
 adapters supported by the nitrox and liquidio drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-cirrus
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Cirrus Logic audio chips
 This package contains the binary firmware for Cirrus Logic audio chips
 like smart amplifiers, converters and DSPs.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-intel-graphics
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Conflicts: firmware-misc-nonfree (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for Intel iGPUs and IPUs
 This package contains the binary firmware for Intel integrated GPUs and
 IPUs supported by the i915, intel-ipu6-isys, ipu3-imgu, mei-vsc-hw, and xe
 drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-intel-misc
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Conflicts: firmware-misc-nonfree (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for miscellaneous Intel devices and chips
 This package contains the binary firmware for miscellaneous Intel devices
 and chips, which do not belong in the iwlwifi, ipw2x00, intel-graphics or
 intel-sound packages.  This includes for example Omni-Path,
 Ethernet/Network chips/devices, and QuickAssist Technology crypto
 accelerators.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-intel-sound
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Intel sound DSPs
 This package contains the binary firmware for Intel SST sound DSPs
 supported by the snd-soc-sst-acpi or snd-intel-sst-acpi driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-ipw2x00
Architecture: all
Pre-Depends: debconf | debconf-2.0
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Intel Pro Wireless 2100, 2200 and 2915
 This package contains the binary firmware for Intel Pro Wireless 2100,
 2200 and 2915 cards supported by the ipw2100 and ipw2200 drivers.
 .
 This firmware is covered by the Intel Pro Wireless 2100 and 2200/2915
 License.  You must agree to the terms of this license before it is
 installed.
Homepage: http://ipw2100.sourceforge.net/firmware.php, http://ipw2200.sourceforge.net/firmware.php

Package: firmware-ivtv
Architecture: all
Pre-Depends: debconf | debconf-2.0
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for iTVC15-family MPEG codecs (ivtv and pvrusb2 drivers)
 This package contains the binary firmware for TV cards with Conexant
 iTVC15-family MPEG codecs, supported by the ivtv and pvrusb2 drivers.
 .
 This firmware is covered by the Hauppauge End-User Firmware License
 Agreement.  You must agree to the terms of this license before it is
 installed.
Homepage: https://web.archive.org/web/20150508162618/http://dl.ivtvdriver.org:80/ivtv/firmware/

Package: firmware-iwlwifi
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Intel Wireless cards
 This package contains the binary firmware for Intel Wireless cards
 supported by the iwl3945, iwl4965, and iwlwifi drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-libertas
Architecture: all
Provides: libertas-firmware
Depends: ${misc:Depends}
Recommends: firmware-marvell-prestera
Suggests: initramfs-tools
Replaces: libertas-firmware
Multi-Arch: foreign
Description: Binary firmware for Marvell wireless cards
 This package contains the binary firmware for wireless network cards with
 Marvell and NXP 88W8xxx chips supported by the libertas_cs, libertas_sdio,
 libertas_spi, libertas_tf_usb, mwifiex_pcie, mwifiex_sdio, mwifiex_usb,
 mwl8k and usb8xxx drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-linux
Architecture: all
Section: non-free-firmware/metapackages
Depends: firmware-linux-free, firmware-linux-nonfree (= ${binary:Version}), ${misc:Depends}
Recommends: intel-microcode, amd64-microcode
Description: Binary firmware for various drivers in the Linux kernel (metapackage)
 This package depends on both free and non-free firmware which may be used
 with drivers in the Linux kernel.

Package: firmware-linux-nonfree
Architecture: all
Section: non-free-firmware/metapackages
Depends: firmware-misc-nonfree (= ${binary:Version}), firmware-amd-graphics (= ${binary:Version}), ${misc:Depends}
Recommends: intel-microcode, amd64-microcode
Description: Binary firmware for various drivers in the Linux kernel (metapackage)
 This package depends on non-free firmware which may be used with drivers
 in the Linux kernel.

Package: firmware-marvell-prestera
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Conflicts: firmware-libertas (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for Marvell Prestera ASIC devices
 This package contains the binary firmware for Marvell Switchdev solution
 Prestera Ethernet switches.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-mediatek
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Conflicts: firmware-misc-nonfree (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for MediaTek and Ralink chips for networking, SoCs and media
 This package contains the binary firmware for MediaTek devices such as
 ethernet/Wi-Fi/Bluetooth chips, SoCs and other chips and devices made by
 MediaTek and Ralink.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-misc-nonfree
Architecture: all
Provides: firmware-adi, firmware-ralink
Depends: ${misc:Depends}
Recommends: firmware-nvidia-graphics, firmware-intel-graphics, firmware-intel-misc, firmware-mediatek
Suggests: initramfs-tools
Conflicts: firmware-ti-connectivity (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for various drivers in the Linux kernel
 This package contains the binary firmware for various drivers in the Linux
 kernel.  This is a collection of firmware blobs which are not individually
 large enough to warrant a standalone package.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-myricom
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Myri-10G Ethernet adapters
 This package contains the binary firmware for Myricom Myri-10G Ethernet
 adapters supported by the myri10ge driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-netronome
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for Netronome network adapters
 This package contains the binary firmware for Netronome network adapters
 supported by the nfp driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-netxen
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign
Description: Binary firmware for QLogic Intelligent Ethernet (3000 and 3100 Series)
 This package contains the binary firmware for QLogic (formerly NetXen)
 Intelligent network adapters supported by the netxen_nic and qlcnic
 drivers.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-nvidia-graphics
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Breaks: initramfs-tools (<< 0.142+deb12u1)
Conflicts: firmware-misc-nonfree (<< 1:20230625-3~)
Multi-Arch: foreign
Description: Binary firmware for Nvidia GPU chips
 This package contains the binary firmware for Nvidia graphics chips using
 the nouveau driver.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-qcom-media
Architecture: all
Section: non-free-firmware/oldlibs
Depends: firmware-qcom-soc, ${misc:Depends}
Multi-Arch: foreign
Description: Binary firmware for Qualcomm graphics/video (dummy package)
 This is a dummy transitional package.  It can be safely removed.

Package: firmware-qcom-soc
Architecture: all
Depends: ${misc:Depends}
Recommends: firmware-atheros
Suggests: initramfs-tools
Replaces: firmware-qcom-media (<< 20200421-1~)
Breaks: firmware-qcom-media (<< 20200421-1~)
Multi-Arch: foreign
Description: Binary firmware for Qualcomm SoCs
 This package contains the binary firmware for Qualcomm Snapdragon SoCs.
Homepage: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git

Package: firmware-qlogic
Architecture: all
Depends: ${misc:Depends}
Suggests: initramfs-tools
Multi-Arch: foreign

=== debian/control ===
Source: raspi-config
Section: utils
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 4.3.0
Vcs-Git: git://git@github.com:RPi-Distro/raspi-config.git
Vcs-Browser: https://github.com/RPi-Distro/raspi-config

Package: raspi-config
Architecture: all
Depends: ${misc:Depends}, whiptail, parted, lua5.1, alsa-utils, psmisc, raspi-utils, dconf-cli
Recommends: triggerhappy, iw
Description: Raspberry Pi configuration tool
 A simple configuration tool for common Raspberry Pi administrative tasks

=== piControl/debian/control ===
Source: picontrol
Section: contrib/electronics
Priority: extra
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9)
Maintainer: KUNBUS GmbH <support@kunbus.com>
Homepage: https://revolution.kunbus.com/
Vcs-Git: https://github.com/RevolutionPi/piControl

Package: pitest
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Revolution Pi command line utility
 Interact with the in-kernel piControl process to list I/O devices and
 gateway devices attached to a RevPi Core, read and write values in the
 process image and reset the piControl process.  Comes with full source
 code.  Revolution Pi is a set of IoT products based on the Raspberry Pi
 and geared towards industrial usage.

=== piControl/debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --sourcedirectory=piTest

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/arm-linux-gnueabihf/lib

=== rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: GPL-2.0-only

# in case debian/rules is executed directly
export DEB_RULES_REQUIRES_ROOT := no

include debian/rules.vars
include /usr/share/dpkg/pkg-info.mk

ifneq (,$(filter-out parallel=1,$(filter parallel=%,$(DEB_BUILD_OPTIONS))))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

# When KBUILD_VERBOSE is undefined (presumably you are directly working with
# the debianized tree), show verbose logs unless DEB_BUILD_OPTION=terse is set.
ifeq ($(origin KBUILD_VERBOSE),undefined)
    ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
        export KBUILD_VERBOSE := 1
    else
        Q := @
    endif
endif

revision = $(shell dpkg-parsechangelog -S Version | sed -n 's/.*-//p')
CROSS_COMPILE ?= $(filter-out $(DEB_BUILD_GNU_TYPE)-, $(DEB_HOST_GNU_TYPE)-)
make-opts = ARCH=$(ARCH) KERNELRELEASE=$(KERNELRELEASE) \
    $(addprefix KBUILD_BUILD_VERSION=,$(revision)) \
    $(addprefix CROSS_COMPILE=,$(CROSS_COMPILE))
meta-pkg-append = $(subst linux,,$(DEB_SOURCE))

binary-targets := $(addprefix binary-, image image-dbg image-meta headers headers-meta libc-dev)

all-packages = $(shell dh_listpackages)
image-package = $(filter linux-image-% user-%, $(filter-out %-dbg %$(meta-pkg-append), $(all-packages)))
image-meta-package = linux-image$(meta-pkg-append)
image-dbg-package = $(filter %-dbg, $(all-packages))
libc-dev-package = $(filter linux-libc-dev, $(all-packages))
headers-package = $(filter linux-headers-%, $(filter-out %$(meta-pkg-append), $(all-packages)))
headers-meta-package = linux-headers$(meta-pkg-append)

mk-files = $(patsubst binary-%,debian/%.files,$1)
package = $($(@:binary-%=%-package))

# DH_OPTION is an environment variable common for all debhelper commands.
# We could 'export' it, but here it is passed from the command line to clarify
# which package is being processed in the build log.
DH_OPTIONS = -p$(package)

define binary
	$(Q)dh_testdir $(DH_OPTIONS)
	$(Q)dh_testroot $(DH_OPTIONS)
	$(Q)dh_prep $(DH_OPTIONS)
	$(Q)+$(MAKE) $(make-opts) run-command KBUILD_RUN_COMMAND='+$$(srctree)/scripts/package/builddeb $(package)'
	$(if $(filter-out %$(meta-pkg-append),$(filter linux-headers-%,$(package))),\
		$(Q)dh_strip $(DH_OPTIONS) --no-automatic-dbgsym)
	$(Q)dh_installdocs $(DH_OPTIONS)
	$(Q)dh_installchangelogs $(DH_OPTIONS)
	$(Q)dh_compress $(DH_OPTIONS)
	$(Q)dh_fixperms $(DH_OPTIONS)
	$(Q)dh_shlibdeps $(DH_OPTIONS)
	$(Q)dh_gencontrol $(DH_OPTIONS) -- -f$(call mk-files,$@)
	$(Q)dh_md5sums $(DH_OPTIONS)
	$(Q)dh_builddeb $(DH_OPTIONS) -- $(addprefix -Z,$(KDEB_COMPRESS))
endef

.PHONY: $(binary-targets)
$(binary-targets): build-arch
	$(Q)truncate -s0 $(call mk-files,$@)
	$(if $(package),$(binary))

.PHONY: binary binary-indep binary-arch
binary: binary-arch binary-indep
binary-indep: build-indep
binary-arch: $(binary-targets)
	$(Q)cat $(call mk-files,$^) > debian/files

.PHONY: build build-indep build-arch
build: build-arch build-indep
build-indep:
build-arch:
	$(Q)$(MAKE) $(make-opts) olddefconfig
	$(Q)$(MAKE) $(make-opts) $(if $(filter um,$(ARCH)),,headers) all

.PHONY: clean
clean:
	$(Q)dh_clean
	$(Q)rm -rf debian/deb-env.vars* debian/*.files
	$(Q)$(MAKE) ARCH=$(ARCH) clean

# If DEB_HOST_ARCH is empty, it is likely that debian/rules was executed
# directly. Run 'dpkg-architecture --print-set --print-format=make' to
# generate a makefile construct that exports all DEB_* variables.
ifndef DEB_HOST_ARCH
include debian/deb-env.vars

debian/deb-env.vars:
	$(Q)dpkg-architecture -a$$(cat debian/arch) --print-set --print-format=make > $@.tmp
	$(Q)mv $@.tmp $@
endif

=== watch ===
version=4

opts="mode=git, pgpmode=none, pretty=0~git%cd.%h, repack, compression=xz" \
 https://github.com/tomba/kmsxx.git \
 HEAD
